1
0

tomcat-7.sh 5.8 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131
  1. #!/bin/bash
  2. # Author: yeho <lj2007331 AT gmail.com>
  3. # BLOG: https://linuxeye.com
  4. #
  5. # Notes: OneinStack for CentOS/RedHat 7+ Debian 9+ and Ubuntu 16+
  6. #
  7. # Project home page:
  8. # https://oneinstack.com
  9. # https://github.com/oneinstack/oneinstack
  10. Install_Tomcat7() {
  11. pushd ${oneinstack_dir}/src > /dev/null
  12. . /etc/profile
  13. id -g ${run_group} >/dev/null 2>&1
  14. [ $? -ne 0 ] && groupadd ${run_group}
  15. id -u ${run_user} >/dev/null 2>&1
  16. [ $? -ne 0 ] && useradd -g ${run_group} -M -s /bin/bash ${run_user} || { [ -z "$(grep ^${run_user} /etc/passwd | grep '/bin/bash')" ] && usermod -g ${run_group} -s /bin/bash ${run_user}; }
  17. # install apr
  18. if [ ! -e "${apr_install_dir}/bin/apr-1-config" ]; then
  19. tar xzf apr-${apr_ver}.tar.gz
  20. pushd apr-${apr_ver} > /dev/null
  21. ./configure --prefix=${apr_install_dir}
  22. make -j ${THREAD} && make install
  23. popd > /dev/null
  24. rm -rf apr-${apr_ver}
  25. fi
  26. tar xzf apache-tomcat-${tomcat7_ver}.tar.gz
  27. [ ! -d "${tomcat_install_dir}" ] && mkdir -p ${tomcat_install_dir}
  28. /bin/cp -R apache-tomcat-${tomcat7_ver}/* ${tomcat_install_dir}
  29. rm -rf ${tomcat_install_dir}/webapps/{docs,examples,host-manager,manager,ROOT/*}
  30. if [ ! -e "${tomcat_install_dir}/conf/server.xml" ]; then
  31. rm -rf ${tomcat_install_dir}
  32. echo "${CFAILURE}Tomcat install failed, Please contact the author! ${CEND}" && grep -Ew 'NAME|ID|ID_LIKE|VERSION_ID|PRETTY_NAME' /etc/os-release
  33. kill -9 $$; exit 1;
  34. fi
  35. /bin/cp catalina-jmx-remote.jar ${tomcat_install_dir}/lib
  36. pushd ${tomcat_install_dir}/bin > /dev/null
  37. tar xzf tomcat-native.tar.gz
  38. pushd tomcat-native-*-src/native > /dev/null
  39. if [ "${armplatform}" == "y" ]; then
  40. ./configure --prefix=${apr_install_dir} --with-apr=${apr_install_dir}
  41. else
  42. ./configure --prefix=${apr_install_dir} --with-apr=${apr_install_dir} --with-ssl=${openssl_install_dir}
  43. fi
  44. make -j ${THREAD} && make install
  45. popd > /dev/null
  46. rm -rf tomcat-native-*
  47. if [ -e "${apr_install_dir}/lib/libtcnative-1.la" ]; then
  48. [ ${Mem} -le 768 ] && let Xms_Mem="${Mem}/3" || Xms_Mem=256
  49. let XmxMem="${Mem}/2"
  50. cat > ${tomcat_install_dir}/bin/setenv.sh << EOF
  51. JAVA_OPTS='-Djava.security.egd=file:/dev/./urandom -server -Xms${Xms_Mem}m -Xmx${XmxMem}m -Dfile.encoding=UTF-8'
  52. CATALINA_OPTS="-Djava.library.path=${apr_install_dir}/lib"
  53. # -Djava.rmi.server.hostname=$IPADDR
  54. # -Dcom.sun.management.jmxremote.password.file=\$CATALINA_BASE/conf/jmxremote.password
  55. # -Dcom.sun.management.jmxremote.access.file=\$CATALINA_BASE/conf/jmxremote.access
  56. # -Dcom.sun.management.jmxremote.ssl=false"
  57. EOF
  58. chmod +x ./*.sh
  59. /bin/mv ${tomcat_install_dir}/conf/server.xml{,_bk}
  60. popd # goto ${oneinstack_dir}/src
  61. /bin/cp ${oneinstack_dir}/config/server.xml ${tomcat_install_dir}/conf
  62. sed -i "s@/usr/local/tomcat@${tomcat_install_dir}@g" ${tomcat_install_dir}/conf/server.xml
  63. if [ ! -e "${nginx_install_dir}/sbin/nginx" -a ! -e "${tengine_install_dir}/sbin/nginx" -a ! -e "${openresty_install_dir}/nginx/sbin/nginx" -a ! -e "${apache_install_dir}/bin/httpd" ]; then
  64. if [ "${PM}" == 'yum' ]; then
  65. if [ "`firewall-cmd --state`" == "running" ]; then
  66. firewall-cmd --permanent --zone=public --add-port=8080/tcp
  67. firewall-cmd --reload
  68. fi
  69. elif [ "${PM}" == 'apt-get' ]; then
  70. if ufw status | grep -wq active; then
  71. ufw allow 8080/tcp
  72. fi
  73. fi
  74. fi
  75. [ ! -d "${tomcat_install_dir}/conf/vhost" ] && mkdir ${tomcat_install_dir}/conf/vhost
  76. cat > ${tomcat_install_dir}/conf/vhost/localhost.xml << EOF
  77. <Host name="localhost" appBase="${wwwroot_dir}/default" unpackWARs="true" autoDeploy="true">
  78. <Context path="" docBase="${wwwroot_dir}/default" reloadable="false" crossContext="true"/>
  79. <Valve className="org.apache.catalina.valves.AccessLogValve" directory="logs"
  80. prefix="localhost_access_log" suffix=".txt" pattern="%h %l %u %t &quot;%r&quot; %s %b" />
  81. <Valve className="org.apache.catalina.valves.RemoteIpValve" remoteIpHeader="X-Forwarded-For"
  82. protocolHeader="X-Forwarded-Proto" protocolHeaderHttpsValue="https"/>
  83. </Host>
  84. EOF
  85. # logrotate tomcat catalina.out
  86. cat > /etc/logrotate.d/tomcat << EOF
  87. ${tomcat_install_dir}/logs/catalina.out {
  88. daily
  89. rotate 5
  90. missingok
  91. dateext
  92. compress
  93. notifempty
  94. copytruncate
  95. }
  96. EOF
  97. [ -z "$(grep '<user username="admin" password=' ${tomcat_install_dir}/conf/tomcat-users.xml)" ] && sed -i "s@^</tomcat-users>@<role rolename=\"admin-gui\"/>\n<role rolename=\"admin-script\"/>\n<role rolename=\"manager-gui\"/>\n<role rolename=\"manager-script\"/>\n<user username=\"admin\" password=\"$(cat /dev/urandom | head -1 | md5sum | head -c 10)\" roles=\"admin-gui,admin-script,manager-gui,manager-script\"/>\n</tomcat-users>@" ${tomcat_install_dir}/conf/tomcat-users.xml
  98. cat > ${tomcat_install_dir}/conf/jmxremote.access << EOF
  99. monitorRole readonly
  100. controlRole readwrite \
  101. create javax.management.monitor.*,javax.management.timer.* \
  102. unregister
  103. EOF
  104. cat > ${tomcat_install_dir}/conf/jmxremote.password << EOF
  105. monitorRole $(cat /dev/urandom | head -1 | md5sum | head -c 8)
  106. # controlRole R&D
  107. EOF
  108. chown -R ${run_user}:${run_group} ${tomcat_install_dir}
  109. /bin/cp ${oneinstack_dir}/init.d/Tomcat-init /etc/init.d/tomcat
  110. sed -i "s@JAVA_HOME=.*@JAVA_HOME=${JAVA_HOME}@" /etc/init.d/tomcat
  111. sed -i "s@^CATALINA_HOME=.*@CATALINA_HOME=${tomcat_install_dir}@" /etc/init.d/tomcat
  112. sed -i "s@^TOMCAT_USER=.*@TOMCAT_USER=${run_user}@" /etc/init.d/tomcat
  113. [ "${PM}" == 'yum' ] && { chkconfig --add tomcat; chkconfig tomcat on; }
  114. [ "${PM}" == 'apt-get' ] && update-rc.d tomcat defaults
  115. echo "${CSUCCESS}Tomcat installed successfully! ${CEND}"
  116. rm -rf apache-tomcat-${tomcat7_ver}
  117. else
  118. popd > /dev/null
  119. echo "${CFAILURE}Tomcat install failed, Please contact the author! ${CEND}" && grep -Ew 'NAME|ID|ID_LIKE|VERSION_ID|PRETTY_NAME' /etc/os-release
  120. fi
  121. service tomcat start
  122. popd > /dev/null
  123. }